Index: java/main/src/main/java/com/framsticks/params/UniqueListAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/UniqueListAccess.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/params/UniqueListAccess.java	(revision 85)
@@ -35,5 +35,5 @@
 		//log.error("accesing unique list through index");
 		//return null;
-		//return new ParamBuilder().setId(Integer.toString(i)).setName(elementAccess.getId()).setType("o " + elementAccess.getId()).build();
+		//return Param.build().setId(Integer.toString(i)).setName(elementAccess.getId()).type("o " + elementAccess.getId()).build();
 	}
 
@@ -44,5 +44,5 @@
 			return getParam(i);
 		}
-		return new ParamBuilder().setId(id).setName(elementAccess.getId()).setType("o " + elementAccess.getId()).build();
+		return Param.build().id(id).name(elementAccess.getId()).type("o " + elementAccess.getId()).finish();
 	}
 
Index: java/main/src/main/java/com/framsticks/params/types/ProcedureParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/ProcedureParam.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/params/types/ProcedureParam.java	(revision 85)
@@ -2,5 +2,4 @@
 
 import com.framsticks.params.Param;
-import com.framsticks.params.ParamBuilder;
 import com.framsticks.util.lang.Strings;
 
@@ -20,5 +19,5 @@
 
 	protected static Param parseType(String type, String name) {
-		return new ParamBuilder().setType(type).setName(name).build();
+		return Param.build().type(type).name(name).finish();
 	}
 
Index: java/main/src/main/java/com/framsticks/parsers/F0Parser.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/F0Parser.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/parsers/F0Parser.java	(revision 85)
@@ -84,7 +84,5 @@
 			ParseException {
 
-		InputStreamReader reader = null;
-		try {
-			reader = new InputStreamReader(is, "UTF-8");
+		try (InputStreamReader reader = new InputStreamReader(is, "UTF-8")) {
 			BufferedReader br = new BufferedReader(reader);
 			while (br.ready()) {
@@ -114,8 +112,4 @@
 			if (result.isEmpty() || !(result.get(0) instanceof Model)) {
 				result.add(0, processLine("m:"));
-			}
-		} finally {
-			if (reader != null) {
-				reader.close();
 			}
 		}
Index: java/main/src/main/java/com/framsticks/parsers/F0Writer.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/F0Writer.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/parsers/F0Writer.java	(revision 85)
@@ -15,5 +15,5 @@
 	protected final SinkInterface sink;
 	protected final Model model;
-	protected boolean omit = true;
+	protected boolean omitDefaults = true;
 
 	public F0Writer(Schema schema, Model model, SinkInterface sink) {
@@ -23,6 +23,6 @@
 	}
 
-	F0Writer omitDefaultValues(boolean omit) {
-		this.omit = omit;
+	public F0Writer setOmitDefaults(boolean omitDefaults) {
+		this.omitDefaults = omitDefaults;
 		return this;
 	}
@@ -49,5 +49,5 @@
 			}
 			Object value = access.get(param, Object.class);
-			if ((param instanceof PrimitiveParam) && Misc.equals(value, ((PrimitiveParam) param).getDef(Object.class))) {
+			if (omitDefaults && (param instanceof PrimitiveParam) && Misc.equals(value, ((PrimitiveParam) param).getDef(Object.class))) {
 				contiguous = false;
 				continue;
Index: java/main/src/main/java/com/framsticks/parsers/FileSource.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/FileSource.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/parsers/FileSource.java	(revision 85)
@@ -2,4 +2,5 @@
 
 import com.framsticks.params.SourceInterface;
+import com.framsticks.util.io.Encoding;
 
 import java.io.*;
@@ -8,21 +9,22 @@
 public class FileSource implements SourceInterface {
 
-	private BufferedReader reader;
-	private String filename;
-	
-	public FileSource(String filename) throws IOException
-	{
+	private final BufferedReader reader;
+	private final String filename;
+
+	protected FileSource(InputStream stream, String filename) {
 		this.filename = filename;
-        reader = new BufferedReader(new FileReader(filename));
+		this.reader = new BufferedReader(new InputStreamReader(stream, Encoding.getFramsticksCharset()));
+	}
+
+	public FileSource(String filename) throws IOException {
+		this(new FileInputStream(filename), filename);
 	}
 
 	public FileSource(InputStream stream) {
-		filename = "<stream>";
-		reader = new BufferedReader(new InputStreamReader(stream));
+		this(stream, "<stream>");
 	}
 
-
-    @Override
-    public String readLine()
+	@Override
+	public String readLine()
 	{
 		try
@@ -35,12 +37,12 @@
 	}
 
-    @Override
-    public String getFilename()
+	@Override
+	public String getFilename()
 	{
 		return filename;
 	}
 
-    @Override
-    public String demangleInclude(String include)
+	@Override
+	public String demangleInclude(String include)
 	{
 		if (!include.contains(java.io.File.separator)) {
@@ -52,10 +54,10 @@
 			}
 			include = currentFilePath + include;
-		}	
+		}
 		return include;
 	}
 
-    @Override
-    public SourceInterface openInclude(String include)
+	@Override
+	public SourceInterface openInclude(String include)
 	{
 		try
@@ -65,18 +67,18 @@
 		catch(IOException e)
 		{
-			
+
 		}
 		return null;
 	}
 
-    @Override
-    public void close()
+	@Override
+	public void close()
 	{
 		try {
 			reader.close();
 		} catch (IOException e) {
-			
+
 		}
 	}
-	
+
 }
Index: java/main/src/main/java/com/framsticks/parsers/GenotypeLoader.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/GenotypeLoader.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/parsers/GenotypeLoader.java	(revision 85)
@@ -22,34 +22,34 @@
 		//getId, group-number, getFlags, getName, getType(getType min max), getHelp
 		entries
-			.append(new ParamBuilder().setId("name").setGroup(0).setName("Name").setType(new StringParam()).setMin(0).setMax(40).build())
-			.append(new ParamBuilder().setId("genotype").setGroup(0).setName("Genotype").setType(new StringParam()).setMin(1).build())
-			.append(new ParamBuilder().setId("info").setGroup(0).setName("Info").setType(new StringParam()).setMin(1).setHelp("Additional information or comments").build())
-			.append(new ParamBuilder().setId("simi").setGroup(1).setFlags(Flags.READONLY | Flags.DONTSAVE).setName("Similarity").setType(new FloatParam()).build())
-			.append(new ParamBuilder().setId("energ0").setGroup(1).setFlags(Flags.READONLY | Flags.DONTSAVE).setName("Starting energy").setType(new FloatParam()).build())
-			.append(new ParamBuilder().setId("strsiz").setGroup(1).setFlags(Flags.READONLY | Flags.DONTSAVE | Flags.USERHIDDEN).setName("Body parts (deprecated; use numparts)").setType(new FloatParam()).build())
-			.append(new ParamBuilder().setId("strjoints").setGroup(1).setFlags(Flags.READONLY | Flags.DONTSAVE | Flags.USERHIDDEN).setName("Body joints (deprecated; use numjoints)").setType(new FloatParam()).build())
-			.append(new ParamBuilder().setId("nnsiz").setGroup(1).setFlags(Flags.READONLY | Flags.DONTSAVE | Flags.USERHIDDEN).setName("Brain size (deprecated; use numneurons)").setType(new FloatParam()).build())
-			.append(new ParamBuilder().setId("nncon").setGroup(1).setFlags(Flags.READONLY | Flags.DONTSAVE | Flags.USERHIDDEN).setName("Brain connections (deprecated; use numconnections)").setType(new FloatParam()).build())
-			.append(new ParamBuilder().setId("numparts").setGroup(1).setFlags(Flags.READONLY | Flags.DONTSAVE).setName("Body parts").setType(new FloatParam()).build())
-			.append(new ParamBuilder().setId("numjoints").setGroup(1).setFlags(Flags.READONLY | Flags.DONTSAVE).setName("Body joints").setType(new FloatParam()).build())
-			.append(new ParamBuilder().setId("numneurons").setGroup(1).setFlags(Flags.READONLY | Flags.DONTSAVE).setName("Brain size").setType(new FloatParam()).build())
-			.append(new ParamBuilder().setId("numconnections").setGroup(1).setFlags(Flags.READONLY | Flags.DONTSAVE).setName("Brain connections").setType(new FloatParam()).build())
-			.append(new ParamBuilder().setId("num").setGroup(2).setName("Ordinal number").setType(new DecimalParam()).build())
-			.append(new ParamBuilder().setId("gnum").setGroup(2).setName("Generation").setType(new DecimalParam()).build())
-			.append(new ParamBuilder().setId("popsiz").setGroup(2).setFlags(Flags.USERHIDDEN).setName("Deprecated; use entities").setType(new DecimalParam()).build())
-			.append(new ParamBuilder().setId("entities").setGroup(2).setFlags(Flags.DONTSAVE).setName("Instances").setType(new DecimalParam()).setHelp("Copies of this genotype").build())
-			.append(new ParamBuilder().setId("lifespan").setGroup(2).setName("Life span").setType(new FloatParam()).setHelp("Average life span").build())
-			.append(new ParamBuilder().setId("velocity").setGroup(2).setName("Velocity").setType(new FloatParam()).setHelp("Average velocity").build())
-			.append(new ParamBuilder().setId("distance").setGroup(2).setName("Distance").setType(new FloatParam()).build())
-			.append(new ParamBuilder().setId("vertvel").setGroup(2).setName("Vertical velocity").setType(new FloatParam()).build())
-			.append(new ParamBuilder().setId("vertpos").setGroup(2).setName("Vertical position").setType(new FloatParam()).build())
-			.append(new ParamBuilder().setId("fit").setGroup(3).setFlags(Flags.READONLY | Flags.DONTSAVE).setName("Fitness").setType(new FloatParam()).build())
-			.append(new ParamBuilder().setId("fit2").setGroup(3).setFlags(Flags.READONLY | Flags.DONTSAVE).setName("Final fitness").setType(new FloatParam()).setHelp("Fitness shifted by (avg-n*stddev)").build())
-			.append(new ParamBuilder().setId("f0genotype").setGroup(4).setFlags(Flags.READONLY | Flags.DONTSAVE).setName("f0 genotype").setType(new StringParam()).setMin(1).setHelp("converted to f0 genotype").build())
-			.append(new ParamBuilder().setId("user1").setGroup(2).setName("User field 1").setType(new UniversalParam()).build())
-			.append(new ParamBuilder().setId("user2").setGroup(2).setName("User field 2").setType(new UniversalParam()).build())
-			.append(new ParamBuilder().setId("user3").setGroup(2).setName("User field 3").setType(new UniversalParam()).build())
-			.append(new ParamBuilder().setId("isValid").setGroup(0).setFlags(Flags.READONLY | Flags.DONTSAVE | Flags.USERHIDDEN).setName("Valid").setType(new DecimalParam()).setMin(0).setMax(1).build())
-			.append(new ParamBuilder().setId("uid").setGroup(0).setFlags(Flags.READONLY | Flags.USERHIDDEN).setName("#").setType("s").setHelp("Unique identifier").build());
+			.append(Param.build().id("name").group(0).name("Name").type(StringParam.class).min(0).max(40))
+			.append(Param.build().id("genotype").group(0).name("Genotype").type(StringParam.class).min(1))
+			.append(Param.build().id("info").group(0).name("Info").type(StringParam.class).min(1).help("Additional information or comments"))
+			.append(Param.build().id("simi").group(1).flags(Flags.READONLY | Flags.DONTSAVE).name("Similarity").type(FloatParam.class))
+			.append(Param.build().id("energ0").group(1).flags(Flags.READONLY | Flags.DONTSAVE).name("Starting energy").type(FloatParam.class))
+			.append(Param.build().id("strsiz").group(1).flags(Flags.READONLY | Flags.DONTSAVE | Flags.USERHIDDEN).name("Body parts (deprecated; use numparts)").type(FloatParam.class))
+			.append(Param.build().id("strjoints").group(1).flags(Flags.READONLY | Flags.DONTSAVE | Flags.USERHIDDEN).name("Body joints (deprecated; use numjoints)").type(FloatParam.class))
+			.append(Param.build().id("nnsiz").group(1).flags(Flags.READONLY | Flags.DONTSAVE | Flags.USERHIDDEN).name("Brain size (deprecated; use numneurons)").type(FloatParam.class))
+			.append(Param.build().id("nncon").group(1).flags(Flags.READONLY | Flags.DONTSAVE | Flags.USERHIDDEN).name("Brain connections (deprecated; use numconnections)").type(FloatParam.class))
+			.append(Param.build().id("numparts").group(1).flags(Flags.READONLY | Flags.DONTSAVE).name("Body parts").type(FloatParam.class))
+			.append(Param.build().id("numjoints").group(1).flags(Flags.READONLY | Flags.DONTSAVE).name("Body joints").type(FloatParam.class))
+			.append(Param.build().id("numneurons").group(1).flags(Flags.READONLY | Flags.DONTSAVE).name("Brain size").type(FloatParam.class))
+			.append(Param.build().id("numconnections").group(1).flags(Flags.READONLY | Flags.DONTSAVE).name("Brain connections").type(FloatParam.class))
+			.append(Param.build().id("num").group(2).name("Ordinal number").type(DecimalParam.class))
+			.append(Param.build().id("gnum").group(2).name("Generation").type(DecimalParam.class))
+			.append(Param.build().id("popsiz").group(2).flags(Flags.USERHIDDEN).name("Deprecated; use entities").type(DecimalParam.class))
+			.append(Param.build().id("entities").group(2).flags(Flags.DONTSAVE).name("Instances").type(DecimalParam.class).help("Copies of this genotype"))
+			.append(Param.build().id("lifespan").group(2).name("Life span").type(FloatParam.class).help("Average life span"))
+			.append(Param.build().id("velocity").group(2).name("Velocity").type(FloatParam.class).help("Average velocity"))
+			.append(Param.build().id("distance").group(2).name("Distance").type(FloatParam.class))
+			.append(Param.build().id("vertvel").group(2).name("Vertical velocity").type(FloatParam.class))
+			.append(Param.build().id("vertpos").group(2).name("Vertical position").type(FloatParam.class))
+			.append(Param.build().id("fit").group(3).flags(Flags.READONLY | Flags.DONTSAVE).name("Fitness").type(FloatParam.class))
+			.append(Param.build().id("fit2").group(3).flags(Flags.READONLY | Flags.DONTSAVE).name("Final fitness").type(FloatParam.class).help("Fitness shifted by (avg-n*stddev)"))
+			.append(Param.build().id("f0genotype").group(4).flags(Flags.READONLY | Flags.DONTSAVE).name("f0 genotype").type(StringParam.class).min(1).help("converted to f0 genotype"))
+			.append(Param.build().id("user1").group(2).name("User field 1").type(UniversalParam.class))
+			.append(Param.build().id("user2").group(2).name("User field 2").type(UniversalParam.class))
+			.append(Param.build().id("user3").group(2).name("User field 3").type(UniversalParam.class))
+			.append(Param.build().id("isValid").group(0).flags(Flags.READONLY | Flags.DONTSAVE | Flags.USERHIDDEN).name("Valid").type(DecimalParam.class).min(0).max(1))
+			.append(Param.build().id("uid").group(0).flags(Flags.READONLY | Flags.USERHIDDEN).name("#").type("s").help("Unique identifier"));
 
 		ReflectionAccess reflectionParam = new ReflectionAccess(Genotype.class, entries);
Index: java/main/src/main/java/com/framsticks/parsers/Loaders.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/Loaders.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/parsers/Loaders.java	(revision 85)
@@ -35,5 +35,5 @@
 					}
 					if (object instanceof ParamBuilder) {
-						result.append(((ParamBuilder) object).build());
+						result.append(((ParamBuilder) object).finish());
 					}
 				}
Index: java/main/src/main/java/com/framsticks/parsers/Schema.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/Schema.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/parsers/Schema.java	(revision 85)
@@ -26,5 +26,5 @@
  * classes definitions that can be used in f0 representation). Definitions are
  * loaded from XML stream.
- * 
+ *
  * @author Jarek Szymczak <name.surname@gmail.com>
  * (please replace name and surname with my personal data)
@@ -46,5 +46,5 @@
 	/**
 	 * Instantiates a new schema.
-	 * 
+	 *
 	 * @param inputStream
 	 *            the xml stream with schema
@@ -104,11 +104,5 @@
 			}
 
-		} catch (IOException e) {
-			logger.fatal("unexpected exception occurred: ", e);
-			throw e;
-		} catch (ParserConfigurationException e) {
-			logger.fatal("unexpected exception occurred: ", e);
-			throw e;
-		} catch (SAXException e) {
+		} catch (IOException | ParserConfigurationException | SAXException e) {
 			logger.fatal("unexpected exception occurred: ", e);
 			throw e;
@@ -121,7 +115,7 @@
 	 * node under certain attribute getName. If value is not present or is other
 	 * getType than integer 0 is returned.
-	 * 
+	 *
 	 * @return attribute value if value exists and it's integer (0 otherwise)
-	 * 
+	 *
 	 */
 	private static int getIntAttribute(NamedNodeMap attributes, String name) {
@@ -152,5 +146,5 @@
 	 * Method used for convenience, it retrieves the value stored in node under
 	 * certain attribute getName. If value is not present method returns null.
-	 * 
+	 *
 	 * @param attributeName
 	 *            the attribute getName
@@ -158,5 +152,5 @@
 	 *            the node
 	 * @return attribute value if value exists (null otherwise)
-	 * 
+	 *
 	 */
 	private static String getAttributeFromNode(String attributeName, Node node) {
@@ -169,5 +163,5 @@
 	/**
 	 * In this method analysis of single class is performed.
-	 * 
+	 *
 	 * @param classNode
 	 *            the class node
@@ -228,5 +222,5 @@
 	/**
 	 * It analyses the single property within the class
-	 * 
+	 *
 	 * @param attributes
 	 *            the attributes of property
@@ -267,26 +261,26 @@
 		}
 
-		ParamBuilder builder = new ParamBuilder();
-		builder.setId(id).setName(name).setHelp(description).setGroup(group).setFlags(flags);
-
-		builder.setType(type);
+		ParamBuilder builder = Param.build();
+		builder.id(id).name(name).help(description).group(group).flags(flags);
+
+		builder.type(type);
 
 		if ("d".equals(type)) {
-			builder.setMin(extractAttribute(attributes, "MIN", Integer.class));
-			builder.setMax(extractAttribute(attributes, "MAX", Integer.class));
-			builder.setDef(extractAttribute(attributes, "DEF", Integer.class));
+			builder.min(extractAttribute(attributes, "MIN", Integer.class));
+			builder.max(extractAttribute(attributes, "MAX", Integer.class));
+			builder.def(extractAttribute(attributes, "DEF", Integer.class));
 		} else if ("f".equals(type)) {
-			builder.setMin(extractAttribute(attributes, "MIN", Double.class));
-			builder.setMax(extractAttribute(attributes, "MAX", Double.class));
-			builder.setDef(extractAttribute(attributes, "DEF", Double.class));
+			builder.min(extractAttribute(attributes, "MIN", Double.class));
+			builder.max(extractAttribute(attributes, "MAX", Double.class));
+			builder.def(extractAttribute(attributes, "DEF", Double.class));
 		} else if ("s".equals(type)) {
-			builder.setMin(extractAttribute(attributes, "MIN", Integer.class));
-			builder.setMax(extractAttribute(attributes, "MAX", Integer.class));
-			builder.setDef(extractAttribute(attributes, "DEF", Integer.class));
-			builder.setDef(getAttribute(attributes, "DEF"));
+			builder.min(extractAttribute(attributes, "MIN", Integer.class));
+			builder.max(extractAttribute(attributes, "MAX", Integer.class));
+			builder.def(extractAttribute(attributes, "DEF", Integer.class));
+			builder.def(getAttribute(attributes, "DEF"));
 		} else {
-			builder.setType(type);
-		}
-		return builder.build();
+			builder.type(type);
+		}
+		return builder.finish();
 	}
 
Index: java/main/src/main/java/com/framsticks/portals/Portal.java
===================================================================
--- java/main/src/main/java/com/framsticks/portals/Portal.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/portals/Portal.java	(revision 85)
@@ -22,5 +22,5 @@
 	public void run() {
 		super.run();
-		new PeriodicTask(this, 1000) {
+		new PeriodicTask<Portal>(this, 1000) {
 
 			@Override
Index: java/main/src/main/java/com/framsticks/portals/PortalEndpoint.java
===================================================================
--- java/main/src/main/java/com/framsticks/portals/PortalEndpoint.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/portals/PortalEndpoint.java	(revision 85)
@@ -1,4 +1,5 @@
 package com.framsticks.portals;
 
+import com.framsticks.core.Instance;
 import com.framsticks.core.Path;
 import com.framsticks.observers.Endpoint;
@@ -7,4 +8,5 @@
 import com.framsticks.util.Logging;
 import org.apache.log4j.Logger;
+import com.framsticks.util.dispatching.RunAt;
 
 /**
@@ -18,48 +20,48 @@
 	}
 
-    @Override
-    public Portal getObserver() {
-        return (Portal) observer;
-    }
+	@Override
+	public Portal getObserver() {
+		return (Portal) observer;
+	}
 
-    @Override
-    public void onRun(Exception e) {
-        assert Dispatching.isThreadSafe();
+	@Override
+	public void onRun(Exception e) {
+		assert Dispatching.isThreadSafe();
 
-        super.onRun(e);
+		super.onRun(e);
 
-        if (e != null) {
-            return;
-        }
-        final String path = "/simulator/genepools/groups/0/genotypes";
-        instance.invokeLater(new Runnable() {
-            @Override
-            public void run() {
-                PortalEndpoint.this.instance.resolve(path, new Future<Path>() {
-                    @Override
-                    public void result(Path result, Exception e) {
-                        Logging.log(log, "resolve", path, e);
-                    }
-                });
-            }
-        });
-    }
+		if (e != null) {
+			return;
+		}
+		final String path = "/simulator/genepools/groups/0/genotypes";
+		instance.invokeLater(new RunAt<Instance>() {
+			@Override
+			public void run() {
+				PortalEndpoint.this.instance.resolve(path, new Future<Path>() {
+					@Override
+					public void result(Path result, Exception e) {
+						Logging.log(log, "resolve", path, e);
+					}
+				});
+			}
+		});
+	}
 
-    @Override
-    public void onStop(Exception e) {
-    }
+	@Override
+	public void onStop(Exception e) {
+	}
 
 
-    /*@Override
-    public void onChange(final Path path) {
-        //if path.getTop().getParam().
-        observer.invokeLater(new Runnable() {
-            @Override
-            public void run() {
-                log.debug("change at " + path);
-            }
-        });
-    }
-    */
+	/*@Override
+	public void onChange(final Path path) {
+		//if path.getTop().getParam().
+		observer.invokeLater(new Runnable() {
+			@Override
+			public void run() {
+				log.debug("change at " + path);
+			}
+		});
+	}
+	*/
 
 
Index: java/main/src/main/java/com/framsticks/remote/RecursiveFetcher.java
===================================================================
--- java/main/src/main/java/com/framsticks/remote/RecursiveFetcher.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/remote/RecursiveFetcher.java	(revision 85)
@@ -12,4 +12,5 @@
 import org.apache.log4j.Logger;
 import static com.framsticks.util.lang.Containers.filterInstanceof;
+import com.framsticks.util.dispatching.RunAt;
 
 /**
@@ -51,5 +52,5 @@
 				if (childPath.isResolved() && instance.getInfoFromCache(childPath) != null) {
 					++dispatched;
-					instance.invokeLater(new Runnable() {
+					instance.invokeLater(new RunAt<Instance>() {
 						@Override
 						public void run() {
Index: java/main/src/main/java/com/framsticks/remote/RemoteInstance.java
===================================================================
--- java/main/src/main/java/com/framsticks/remote/RemoteInstance.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/remote/RemoteInstance.java	(revision 85)
@@ -17,4 +17,5 @@
 import com.framsticks.util.lang.Casting;
 import com.framsticks.util.lang.Pair;
+import com.framsticks.util.dispatching.RunAt;
 
 import org.apache.commons.configuration.Configuration;
@@ -33,8 +34,8 @@
 	protected ClientConnection connection;
 
-	protected final Set<Pair<Path, Subscription>> subscriptions = new HashSet<Pair<Path, Subscription>>();
-
-	public Pair<Path, Subscription> getSubscription(Path path) {
-		for (Pair<Path, Subscription> s : subscriptions) {
+	protected final Set<Pair<Path, Subscription<?>>> subscriptions = new HashSet<>();
+
+	public Pair<Path, Subscription<?>> getSubscription(Path path) {
+		for (Pair<Path, Subscription<?>> s : subscriptions) {
 			if (s.first.matches(path)) {
 				return s;
@@ -67,5 +68,5 @@
 						}
 
-						invokeLater(new Runnable() {
+						invokeLater(new RunAt<Instance>() {
 							@Override
 							public void run() {
@@ -85,8 +86,8 @@
 										EventParam param = getParam(simulator, "running_changed", EventParam.class);
 										assert param != null;
-										connection.subscribe(simulator.getTextual() + "/" + param.getId(), new LoggingSubscriptionCallback(log, "server running state change", new EventCallback() {
+										connection.subscribe(simulator.getTextual() + "/" + param.getId(), RemoteInstance.this, new LoggingSubscriptionCallback<Instance>(log, "server running state change", new EventCallback() {
 											@Override
 											public void call(List<File> files) {
-												invokeLater(new Runnable() {
+												invokeLater(new RunAt<Instance>() {
 													@Override
 													public void run() {
@@ -96,5 +97,5 @@
 											}
 										}));
-										new PeriodicTask(RemoteInstance.this, 1000) {
+										new PeriodicTask<Instance>(RemoteInstance.this, 1000) {
 											@Override
 											public void run() {
@@ -187,5 +188,5 @@
 		assert param != null;
 		assert path.isResolved();
-		connection.send(new GetRequest().setField(param.getId()).setPath(path.getTextual()), this, new ResponseCallback() {
+		connection.send(new GetRequest().field(param.getId()).path(path.getTextual()), this, new ResponseCallback<Instance>() {
 			@Override
 			public void process(Response response) {
@@ -232,5 +233,5 @@
 
 		//TODO: if the info is in the cache, then don't communicate
-		connection.send(new InfoRequest().setPath(path.getTextual()), this, new ResponseCallback() {
+		connection.send(new InfoRequest().path(path.getTextual()), this, new ResponseCallback<Instance>() {
 			@Override
 			public void process(Response response) {
@@ -268,5 +269,5 @@
 
 		log.trace("fetching values for " + path);
-		connection.send(new GetRequest().setPath(path.getTextual()), this, new ResponseCallback() {
+		connection.send(new GetRequest().path(path.getTextual()), this, new ResponseCallback<Instance>() {
 			@Override
 			public void process(Response response) {
@@ -344,10 +345,10 @@
 		}
 
-		final Pair<Path, Subscription> temporary = new Pair<Path, Subscription>(path, null);
+		final Pair<Path, Subscription<?>> temporary = new Pair<>(path, null);
 		subscriptions.add(temporary);
 
-		connection.subscribe(path.getTextual() + "_changed", new SubscriptionCallback() {
-			@Override
-			public EventCallback subscribed(final Subscription subscription) {
+		connection.subscribe(path.getTextual() + "_changed", this, new SubscriptionCallback<Instance>() {
+			@Override
+			public EventCallback subscribed(final Subscription<? super Instance> subscription) {
 				if (subscription == null) {
 					log.error("failed to subscribe for change event for " + path);
@@ -355,10 +356,10 @@
 				}
 				log.debug("subscribed for change event for " + path);
-				subscription.setDispatcher(RemoteInstance.this);
-				RemoteInstance.this.invokeLater(new Runnable() {
+				// subscription.setDispatcher(RemoteInstance.this);
+				RemoteInstance.this.invokeLater(new RunAt<Instance>() {
 					@Override
 					public void run() {
 						subscriptions.remove(temporary);
-						subscriptions.add(new Pair<Path, Subscription>(path, subscription));
+						subscriptions.add(new Pair<Path, Subscription<?>>(path, subscription));
 					}
 				});
@@ -459,5 +460,5 @@
 
 		log.trace("storing value " + param + " for " + path);
-		connection.send(new SetRequest().value(value.toString()).setField(param.getId()).setPath(path.getTextual()), this, new StateCallback() {
+		connection.send(new SetRequest().value(value.toString()).field(param.getId()).path(path.getTextual()), this, new StateCallback<Instance>() {
 			@Override
 			public void call(Exception e) {
Index: java/main/src/main/java/com/framsticks/util/PeriodicTask.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/PeriodicTask.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/PeriodicTask.java	(revision 85)
@@ -3,28 +3,29 @@
 import com.framsticks.util.dispatching.Dispatcher;
 import com.framsticks.util.dispatching.Task;
+import com.framsticks.util.dispatching.RunAt;
 
 /**
  * @author Piotr Sniegowski
  */
-public abstract class PeriodicTask implements Runnable {
+public abstract class PeriodicTask<C> extends RunAt<C> {
 
-    protected final long period;
-    protected Dispatcher dispatcher;
+	protected final long period;
+	protected Dispatcher<? super C> dispatcher;
 
-    public PeriodicTask(Dispatcher dispatcher, long period) {
-        this.period = period;
-        this.dispatcher = dispatcher;
-        dispatcher.invokeLater(this);
-    }
+	public PeriodicTask(Dispatcher<? super C> dispatcher, long period) {
+		this.period = period;
+		this.dispatcher = dispatcher;
+		dispatcher.invokeLater(this);
+	}
 
 
-    public void again() {
-        dispatcher.invokeLater(new Task(System.currentTimeMillis() + period) {
-            @Override
-            public void run() {
-                PeriodicTask.this.run();
-            }
-        });
-    }
+	public void again() {
+		dispatcher.invokeLater(new Task<C>(System.currentTimeMillis() + period) {
+			@Override
+			public void run() {
+				PeriodicTask.this.run();
+			}
+		});
+	}
 
 }
Index: java/main/src/main/java/com/framsticks/util/StateFunctor.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/StateFunctor.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/StateFunctor.java	(revision 85)
@@ -5,4 +5,5 @@
  */
 public interface StateFunctor {
+	//TODO RunAt
 	public void call(Exception e);
 }
Index: java/main/src/main/java/com/framsticks/util/dispatching/AtOnceDispatcher.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/AtOnceDispatcher.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/dispatching/AtOnceDispatcher.java	(revision 85)
@@ -4,16 +4,22 @@
  * @author Piotr Sniegowski
  */
-public class AtOnceDispatcher implements Dispatcher {
+public class AtOnceDispatcher<C> implements Dispatcher<C> {
 
-    public static final AtOnceDispatcher instance = new AtOnceDispatcher();
+	@SuppressWarnings("rawtypes")
+	protected static final AtOnceDispatcher instance = new AtOnceDispatcher();
 
-    @Override
-    public final boolean isActive() {
-        return true;
-    }
+	@SuppressWarnings("unchecked")
+	public static <C> Dispatcher<C> getInstance() {
+		return (Dispatcher<C>) instance;
+	}
 
-    @Override
-    public final void invokeLater(Runnable runnable) {
-        runnable.run();
-    }
+	@Override
+	public final boolean isActive() {
+		return true;
+	}
+
+	@Override
+	public final void invokeLater(RunAt<? extends C> runnable) {
+		runnable.run();
+	}
 }
Index: java/main/src/main/java/com/framsticks/util/dispatching/Dispatcher.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Dispatcher.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Dispatcher.java	(revision 85)
@@ -4,6 +4,6 @@
  * @author Piotr Sniegowski
  */
-public interface Dispatcher {
-    public boolean isActive();
-    public void invokeLater(Runnable runnable);
+public interface Dispatcher<C> {
+	public boolean isActive();
+	public void invokeLater(RunAt<? extends C> runnable);
 }
